unit Unit1;

interface

uses
    Windows, Classes, Controls, Forms, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//  Nbv{[h̃t@CXg擾 
//  http://www.bekkoame.ne.jp/~ilgg/VBMain/VB/ClipBoard/FileList.html
//  http://web.archive.org/web/20040206151337/http://www.bekkoame.ne.jp/~ilgg/VBMain/VB/ClipBoard/FileList.html
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N014.html

uses
    ClipBrd, ShellApi;

//---------------------------------------------------------------------------
//  ֐F IsFileDropData
//  @  \F Nbv{[h̃f[^t@Chbv`肷
//    F hWnd c EChEnh
//  ԂlF TrueFt@Chbv`   False:ł͂Ȃ
//    lF ɂȂ
//---------------------------------------------------------------------------
function IsFileDropData(const WH: HWND): Boolean;
const
    CF_HDROP = 15; 
var
    ClipboardFormat: Cardinal;
begin
    Result := False;
    ClipboardFormat := 0;

    //  Nbv{[hJ
    if OpenClipboard(WH) then
    begin
        try
            //  Nbv{[hɊi[Ăf[^̌`擾
            repeat
                ClipboardFormat := EnumClipboardFormats(ClipboardFormat);
                if (ClipboardFormat = CF_HDROP) then
                begin
                    Result := True;
                    break;
                end;
            until
                (ClipboardFormat = 0)
            ;
        finally
            //  Nbv{[h
            CloseClipboard();
        end;
    end;
end;

//---------------------------------------------------------------------------
//  ֐F GetFileDropData
//  @  \F t@Chbv`f[^擾
//    F hWnd   c CEChẼnh
//           FileList c t@Chbv`f[^
//  ԂlF FTrue  G[FFalse
//    lF Cɕ\
//---------------------------------------------------------------------------
function GetFileDropData(WH: HWND; FileList: TStrings): Boolean;
var
    ClipHandle: THandle;
    MemDrop: Pointer;
    i, Count: integer;
    FileName: Array[0..MAX_PATH] of Char;
begin
    Result := False;
    //  Nbv{[hJ
    if (OpenClipboard(WH)) then
    begin
        try
            //  Nbv{[hf[^擾
            ClipHandle := GetClipboardData(CF_HDROP);

            //  
            if (ClipHandle <> 0) then
            begin
                //  [IuWFNgbN
                MemDrop := GlobalLock(ClipHandle);

                //  
                if (MemDrop <> nil) then
                begin
                    try
                        //  Nbv{[hɊi[ꂽt@C擾
                        Count := DragQueryFile(Integer(MemDrop), DWORD(-1),
                                                FileName, SizeOf(FileName));
                        for i := 0 to Count - 1 do
                        begin
                            //  ꂼ̃t@C擾
                            DragQueryFile(Integer(MemDrop), i,
                                            FileName, SizeOf(FileName));
                            //  Xgɒǉ
                            FileList.Add(FileName);
                        end;
                        Result := True;
                    finally
                        //  bN
                        GlobalUnlock(ClipHandle);
                    end;
                end;
            end;
        finally
            //  Nbv{[h
            CloseClipboard();
        end;
    end;
end;

//---------------------------------------------------------------------------
//  ĂяoTv
//  GNXv[œKȃt@CRs[Ɏs
//  Rs[t@C̃tpX\B
//---------------------------------------------------------------------------
procedure TForm1.Button1Click(Sender: TObject);
begin
    Memo1.Clear();

    //  Nbv{[h̃t@CXg
    if (IsFileDropData(Self.Handle)) then
    begin
        //  Nbv{[ht@CXg擾
        if (GetFileDropData(Self.Handle, Memo1.Lines)) then
        begin
            MessageBox(Self.Handle, PChar(''),
                        PChar(Application.Title),
                        MB_OK + MB_ICONINFORMATION);
        end;
    end;
end;

end.

